<?php

namespace App\ExternalApis\ConsendoAxp\Soap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AxpActivityType StructType
 * @subpackage Structs
 */
class AxpActivityType extends AbstractStructBase
{
    /**
     * The aid
     * @var int
     */
    public $aid;
    /**
     * The label
     * @var string
     */
    public $label;
    /**
     * The short_label
     * @var string
     */
    public $short_label;
    /**
     * The context
     * @var int
     */
    public $context;
    /**
     * The active
     * @var bool
     */
    public $active;
    /**
     * The sort_id
     * @var int
     */
    public $sort_id;
    /**
     * The sort_key
     * @var int
     */
    public $sort_key;
    /**
     * The extra_fields
     * @var bool
     */
    public $extra_fields;
    /**
     * The tofrom_fields
     * @var bool
     */
    public $tofrom_fields;
    /**
     * Constructor method for AxpActivityType
     * @uses AxpActivityType::setAid()
     * @uses AxpActivityType::setLabel()
     * @uses AxpActivityType::setShort_label()
     * @uses AxpActivityType::setContext()
     * @uses AxpActivityType::setActive()
     * @uses AxpActivityType::setSort_id()
     * @uses AxpActivityType::setSort_key()
     * @uses AxpActivityType::setExtra_fields()
     * @uses AxpActivityType::setTofrom_fields()
     * @param int $aid
     * @param string $label
     * @param string $short_label
     * @param int $context
     * @param bool $active
     * @param int $sort_id
     * @param int $sort_key
     * @param bool $extra_fields
     * @param bool $tofrom_fields
     */
    public function __construct($aid = null, $label = null, $short_label = null, $context = null, $active = null, $sort_id = null, $sort_key = null, $extra_fields = null, $tofrom_fields = null)
    {
        $this
            ->setAid($aid)
            ->setLabel($label)
            ->setShort_label($short_label)
            ->setContext($context)
            ->setActive($active)
            ->setSort_id($sort_id)
            ->setSort_key($sort_key)
            ->setExtra_fields($extra_fields)
            ->setTofrom_fields($tofrom_fields);
    }
    /**
     * Get aid value
     * @return int|null
     */
    public function getAid()
    {
        return $this->aid;
    }
    /**
     * Set aid value
     * @param int $aid
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpActivityType
     */
    public function setAid($aid = null)
    {
        // validation for constraint: int
        if (!is_null($aid) && !is_numeric($aid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($aid)), __LINE__);
        }
        $this->aid = $aid;
        return $this;
    }
    /**
     * Get label value
     * @return string|null
     */
    public function getLabel()
    {
        return $this->label;
    }
    /**
     * Set label value
     * @param string $label
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpActivityType
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($label)), __LINE__);
        }
        $this->label = $label;
        return $this;
    }
    /**
     * Get short_label value
     * @return string|null
     */
    public function getShort_label()
    {
        return $this->short_label;
    }
    /**
     * Set short_label value
     * @param string $short_label
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpActivityType
     */
    public function setShort_label($short_label = null)
    {
        // validation for constraint: string
        if (!is_null($short_label) && !is_string($short_label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($short_label)), __LINE__);
        }
        $this->short_label = $short_label;
        return $this;
    }
    /**
     * Get context value
     * @return int|null
     */
    public function getContext()
    {
        return $this->context;
    }
    /**
     * Set context value
     * @param int $context
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpActivityType
     */
    public function setContext($context = null)
    {
        // validation for constraint: int
        if (!is_null($context) && !is_numeric($context)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($context)), __LINE__);
        }
        $this->context = $context;
        return $this;
    }
    /**
     * Get active value
     * @return bool|null
     */
    public function getActive()
    {
        return $this->active;
    }
    /**
     * Set active value
     * @param bool $active
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpActivityType
     */
    public function setActive($active = null)
    {
        // validation for constraint: boolean
        if (!is_null($active) && !is_bool($active)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($active)), __LINE__);
        }
        $this->active = $active;
        return $this;
    }
    /**
     * Get sort_id value
     * @return int|null
     */
    public function getSort_id()
    {
        return $this->sort_id;
    }
    /**
     * Set sort_id value
     * @param int $sort_id
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpActivityType
     */
    public function setSort_id($sort_id = null)
    {
        // validation for constraint: int
        if (!is_null($sort_id) && !is_numeric($sort_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sort_id)), __LINE__);
        }
        $this->sort_id = $sort_id;
        return $this;
    }
    /**
     * Get sort_key value
     * @return int|null
     */
    public function getSort_key()
    {
        return $this->sort_key;
    }
    /**
     * Set sort_key value
     * @param int $sort_key
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpActivityType
     */
    public function setSort_key($sort_key = null)
    {
        // validation for constraint: int
        if (!is_null($sort_key) && !is_numeric($sort_key)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sort_key)), __LINE__);
        }
        $this->sort_key = $sort_key;
        return $this;
    }
    /**
     * Get extra_fields value
     * @return bool|null
     */
    public function getExtra_fields()
    {
        return $this->extra_fields;
    }
    /**
     * Set extra_fields value
     * @param bool $extra_fields
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpActivityType
     */
    public function setExtra_fields($extra_fields = null)
    {
        // validation for constraint: boolean
        if (!is_null($extra_fields) && !is_bool($extra_fields)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($extra_fields)), __LINE__);
        }
        $this->extra_fields = $extra_fields;
        return $this;
    }
    /**
     * Get tofrom_fields value
     * @return bool|null
     */
    public function getTofrom_fields()
    {
        return $this->tofrom_fields;
    }
    /**
     * Set tofrom_fields value
     * @param bool $tofrom_fields
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpActivityType
     */
    public function setTofrom_fields($tofrom_fields = null)
    {
        // validation for constraint: boolean
        if (!is_null($tofrom_fields) && !is_bool($tofrom_fields)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($tofrom_fields)), __LINE__);
        }
        $this->tofrom_fields = $tofrom_fields;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpActivityType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
