<?php

namespace App\ExternalApis\ConsendoAxp\Soap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AxpCustomerGroup StructType
 * @subpackage Structs
 */
class AxpCustomerGroup extends AbstractStructBase
{
    /**
     * The cgid
     * @var int
     */
    public $cgid;
    /**
     * The label
     * @var string
     */
    public $label;
    /**
     * The flags
     * @var int
     */
    public $flags;
    /**
     * Constructor method for AxpCustomerGroup
     * @uses AxpCustomerGroup::setCgid()
     * @uses AxpCustomerGroup::setLabel()
     * @uses AxpCustomerGroup::setFlags()
     * @param int $cgid
     * @param string $label
     * @param int $flags
     */
    public function __construct($cgid = null, $label = null, $flags = null)
    {
        $this
            ->setCgid($cgid)
            ->setLabel($label)
            ->setFlags($flags);
    }
    /**
     * Get cgid value
     * @return int|null
     */
    public function getCgid()
    {
        return $this->cgid;
    }
    /**
     * Set cgid value
     * @param int $cgid
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpCustomerGroup
     */
    public function setCgid($cgid = null)
    {
        // validation for constraint: int
        if (!is_null($cgid) && !is_numeric($cgid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($cgid)), __LINE__);
        }
        $this->cgid = $cgid;
        return $this;
    }
    /**
     * Get label value
     * @return string|null
     */
    public function getLabel()
    {
        return $this->label;
    }
    /**
     * Set label value
     * @param string $label
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpCustomerGroup
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($label)), __LINE__);
        }
        $this->label = $label;
        return $this;
    }
    /**
     * Get flags value
     * @return int|null
     */
    public function getFlags()
    {
        return $this->flags;
    }
    /**
     * Set flags value
     * @param int $flags
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpCustomerGroup
     */
    public function setFlags($flags = null)
    {
        // validation for constraint: int
        if (!is_null($flags) && !is_numeric($flags)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($flags)), __LINE__);
        }
        $this->flags = $flags;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpCustomerGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
