<?php

namespace App\ExternalApis\ConsendoAxp\Soap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AxpDepartment StructType
 * @subpackage Structs
 */
class AxpDepartment extends AbstractStructBase
{
    /**
     * The did
     * @var int
     */
    public $did;
    /**
     * The label
     * @var string
     */
    public $label;
    /**
     * The identification
     * @var string
     */
    public $identification;
    /**
     * The appl_cons
     * @var int
     */
    public $appl_cons;
    /**
     * The department_id
     * @var string
     */
    public $department_id;
    /**
     * The intern_dept
     * @var bool
     */
    public $intern_dept;
    /**
     * The addr1
     * @var string
     */
    public $addr1;
    /**
     * The zipcity
     * @var string
     */
    public $zipcity;
    /**
     * The phone1
     * @var string
     */
    public $phone1;
    /**
     * The link
     * @var string
     */
    public $link;
    /**
     * The link_alias
     * @var string
     */
    public $link_alias;
    /**
     * The label_short
     * @var string
     */
    public $label_short;
    /**
     * Constructor method for AxpDepartment
     * @uses AxpDepartment::setDid()
     * @uses AxpDepartment::setLabel()
     * @uses AxpDepartment::setIdentification()
     * @uses AxpDepartment::setAppl_cons()
     * @uses AxpDepartment::setDepartment_id()
     * @uses AxpDepartment::setIntern_dept()
     * @uses AxpDepartment::setAddr1()
     * @uses AxpDepartment::setZipcity()
     * @uses AxpDepartment::setPhone1()
     * @uses AxpDepartment::setLink()
     * @uses AxpDepartment::setLink_alias()
     * @uses AxpDepartment::setLabel_short()
     * @param int $did
     * @param string $label
     * @param string $identification
     * @param int $appl_cons
     * @param string $department_id
     * @param bool $intern_dept
     * @param string $addr1
     * @param string $zipcity
     * @param string $phone1
     * @param string $link
     * @param string $link_alias
     * @param string $label_short
     */
    public function __construct($did = null, $label = null, $identification = null, $appl_cons = null, $department_id = null, $intern_dept = null, $addr1 = null, $zipcity = null, $phone1 = null, $link = null, $link_alias = null, $label_short = null)
    {
        $this
            ->setDid($did)
            ->setLabel($label)
            ->setIdentification($identification)
            ->setAppl_cons($appl_cons)
            ->setDepartment_id($department_id)
            ->setIntern_dept($intern_dept)
            ->setAddr1($addr1)
            ->setZipcity($zipcity)
            ->setPhone1($phone1)
            ->setLink($link)
            ->setLink_alias($link_alias)
            ->setLabel_short($label_short);
    }
    /**
     * Get did value
     * @return int|null
     */
    public function getDid()
    {
        return $this->did;
    }
    /**
     * Set did value
     * @param int $did
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public function setDid($did = null)
    {
        // validation for constraint: int
        if (!is_null($did) && !is_numeric($did)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($did)), __LINE__);
        }
        $this->did = $did;
        return $this;
    }
    /**
     * Get label value
     * @return string|null
     */
    public function getLabel()
    {
        return $this->label;
    }
    /**
     * Set label value
     * @param string $label
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($label)), __LINE__);
        }
        $this->label = $label;
        return $this;
    }
    /**
     * Get identification value
     * @return string|null
     */
    public function getIdentification()
    {
        return $this->identification;
    }
    /**
     * Set identification value
     * @param string $identification
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public function setIdentification($identification = null)
    {
        // validation for constraint: string
        if (!is_null($identification) && !is_string($identification)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identification)), __LINE__);
        }
        $this->identification = $identification;
        return $this;
    }
    /**
     * Get appl_cons value
     * @return int|null
     */
    public function getAppl_cons()
    {
        return $this->appl_cons;
    }
    /**
     * Set appl_cons value
     * @param int $appl_cons
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public function setAppl_cons($appl_cons = null)
    {
        // validation for constraint: int
        if (!is_null($appl_cons) && !is_numeric($appl_cons)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($appl_cons)), __LINE__);
        }
        $this->appl_cons = $appl_cons;
        return $this;
    }
    /**
     * Get department_id value
     * @return string|null
     */
    public function getDepartment_id()
    {
        return $this->department_id;
    }
    /**
     * Set department_id value
     * @param string $department_id
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public function setDepartment_id($department_id = null)
    {
        // validation for constraint: string
        if (!is_null($department_id) && !is_string($department_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($department_id)), __LINE__);
        }
        $this->department_id = $department_id;
        return $this;
    }
    /**
     * Get intern_dept value
     * @return bool|null
     */
    public function getIntern_dept()
    {
        return $this->intern_dept;
    }
    /**
     * Set intern_dept value
     * @param bool $intern_dept
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public function setIntern_dept($intern_dept = null)
    {
        // validation for constraint: boolean
        if (!is_null($intern_dept) && !is_bool($intern_dept)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($intern_dept)), __LINE__);
        }
        $this->intern_dept = $intern_dept;
        return $this;
    }
    /**
     * Get addr1 value
     * @return string|null
     */
    public function getAddr1()
    {
        return $this->addr1;
    }
    /**
     * Set addr1 value
     * @param string $addr1
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public function setAddr1($addr1 = null)
    {
        // validation for constraint: string
        if (!is_null($addr1) && !is_string($addr1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addr1)), __LINE__);
        }
        $this->addr1 = $addr1;
        return $this;
    }
    /**
     * Get zipcity value
     * @return string|null
     */
    public function getZipcity()
    {
        return $this->zipcity;
    }
    /**
     * Set zipcity value
     * @param string $zipcity
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public function setZipcity($zipcity = null)
    {
        // validation for constraint: string
        if (!is_null($zipcity) && !is_string($zipcity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($zipcity)), __LINE__);
        }
        $this->zipcity = $zipcity;
        return $this;
    }
    /**
     * Get phone1 value
     * @return string|null
     */
    public function getPhone1()
    {
        return $this->phone1;
    }
    /**
     * Set phone1 value
     * @param string $phone1
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public function setPhone1($phone1 = null)
    {
        // validation for constraint: string
        if (!is_null($phone1) && !is_string($phone1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phone1)), __LINE__);
        }
        $this->phone1 = $phone1;
        return $this;
    }
    /**
     * Get link value
     * @return string|null
     */
    public function getLink()
    {
        return $this->link;
    }
    /**
     * Set link value
     * @param string $link
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public function setLink($link = null)
    {
        // validation for constraint: string
        if (!is_null($link) && !is_string($link)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($link)), __LINE__);
        }
        $this->link = $link;
        return $this;
    }
    /**
     * Get link_alias value
     * @return string|null
     */
    public function getLink_alias()
    {
        return $this->link_alias;
    }
    /**
     * Set link_alias value
     * @param string $link_alias
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public function setLink_alias($link_alias = null)
    {
        // validation for constraint: string
        if (!is_null($link_alias) && !is_string($link_alias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($link_alias)), __LINE__);
        }
        $this->link_alias = $link_alias;
        return $this;
    }
    /**
     * Get label_short value
     * @return string|null
     */
    public function getLabel_short()
    {
        return $this->label_short;
    }
    /**
     * Set label_short value
     * @param string $label_short
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public function setLabel_short($label_short = null)
    {
        // validation for constraint: string
        if (!is_null($label_short) && !is_string($label_short)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($label_short)), __LINE__);
        }
        $this->label_short = $label_short;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpDepartment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
