<?php

namespace App\ExternalApis\ConsendoAxp\Soap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AxpStampclockData StructType
 * @subpackage Structs
 */
class AxpStampclockData extends AbstractStructBase
{
    /**
     * The terminal
     * @var string
     */
    public $terminal;
    /**
     * The cpr
     * @var string
     */
    public $cpr;
    /**
     * The date
     * @var string
     */
    public $date;
    /**
     * The time
     * @var string
     */
    public $time;
    /**
     * Constructor method for AxpStampclockData
     * @uses AxpStampclockData::setTerminal()
     * @uses AxpStampclockData::setCpr()
     * @uses AxpStampclockData::setDate()
     * @uses AxpStampclockData::setTime()
     * @param string $terminal
     * @param string $cpr
     * @param string $date
     * @param string $time
     */
    public function __construct($terminal = null, $cpr = null, $date = null, $time = null)
    {
        $this
            ->setTerminal($terminal)
            ->setCpr($cpr)
            ->setDate($date)
            ->setTime($time);
    }
    /**
     * Get terminal value
     * @return string|null
     */
    public function getTerminal()
    {
        return $this->terminal;
    }
    /**
     * Set terminal value
     * @param string $terminal
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpStampclockData
     */
    public function setTerminal($terminal = null)
    {
        // validation for constraint: string
        if (!is_null($terminal) && !is_string($terminal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($terminal)), __LINE__);
        }
        $this->terminal = $terminal;
        return $this;
    }
    /**
     * Get cpr value
     * @return string|null
     */
    public function getCpr()
    {
        return $this->cpr;
    }
    /**
     * Set cpr value
     * @param string $cpr
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpStampclockData
     */
    public function setCpr($cpr = null)
    {
        // validation for constraint: string
        if (!is_null($cpr) && !is_string($cpr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cpr)), __LINE__);
        }
        $this->cpr = $cpr;
        return $this;
    }
    /**
     * Get date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->date;
    }
    /**
     * Set date value
     * @param string $date
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpStampclockData
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($date)), __LINE__);
        }
        $this->date = $date;
        return $this;
    }
    /**
     * Get time value
     * @return string|null
     */
    public function getTime()
    {
        return $this->time;
    }
    /**
     * Set time value
     * @param string $time
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpStampclockData
     */
    public function setTime($time = null)
    {
        // validation for constraint: string
        if (!is_null($time) && !is_string($time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($time)), __LINE__);
        }
        $this->time = $time;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpStampclockData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
