<?php

namespace App\ExternalApis\ConsendoAxp\Soap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AxpTempBizareas StructType
 * @subpackage Structs
 */
class AxpTempBizareas extends AbstractStructBase
{
    /**
     * The tid
     * @var int
     */
    public $tid;
    /**
     * The baid
     * @var int
     */
    public $baid;
    /**
     * The label
     * @var string
     */
    public $label;
    /**
     * The temporary
     * @var bool
     */
    public $temporary;
    /**
     * The permanent
     * @var bool
     */
    public $permanent;
    /**
     * Constructor method for AxpTempBizareas
     * @uses AxpTempBizareas::setTid()
     * @uses AxpTempBizareas::setBaid()
     * @uses AxpTempBizareas::setLabel()
     * @uses AxpTempBizareas::setTemporary()
     * @uses AxpTempBizareas::setPermanent()
     * @param int $tid
     * @param int $baid
     * @param string $label
     * @param bool $temporary
     * @param bool $permanent
     */
    public function __construct($tid = null, $baid = null, $label = null, $temporary = null, $permanent = null)
    {
        $this
            ->setTid($tid)
            ->setBaid($baid)
            ->setLabel($label)
            ->setTemporary($temporary)
            ->setPermanent($permanent);
    }
    /**
     * Get tid value
     * @return int|null
     */
    public function getTid()
    {
        return $this->tid;
    }
    /**
     * Set tid value
     * @param int $tid
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempBizareas
     */
    public function setTid($tid = null)
    {
        // validation for constraint: int
        if (!is_null($tid) && !is_numeric($tid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($tid)), __LINE__);
        }
        $this->tid = $tid;
        return $this;
    }
    /**
     * Get baid value
     * @return int|null
     */
    public function getBaid()
    {
        return $this->baid;
    }
    /**
     * Set baid value
     * @param int $baid
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempBizareas
     */
    public function setBaid($baid = null)
    {
        // validation for constraint: int
        if (!is_null($baid) && !is_numeric($baid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($baid)), __LINE__);
        }
        $this->baid = $baid;
        return $this;
    }
    /**
     * Get label value
     * @return string|null
     */
    public function getLabel()
    {
        return $this->label;
    }
    /**
     * Set label value
     * @param string $label
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempBizareas
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($label)), __LINE__);
        }
        $this->label = $label;
        return $this;
    }
    /**
     * Get temporary value
     * @return bool|null
     */
    public function getTemporary()
    {
        return $this->temporary;
    }
    /**
     * Set temporary value
     * @param bool $temporary
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempBizareas
     */
    public function setTemporary($temporary = null)
    {
        // validation for constraint: boolean
        if (!is_null($temporary) && !is_bool($temporary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($temporary)), __LINE__);
        }
        $this->temporary = $temporary;
        return $this;
    }
    /**
     * Get permanent value
     * @return bool|null
     */
    public function getPermanent()
    {
        return $this->permanent;
    }
    /**
     * Set permanent value
     * @param bool $permanent
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempBizareas
     */
    public function setPermanent($permanent = null)
    {
        // validation for constraint: boolean
        if (!is_null($permanent) && !is_bool($permanent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($permanent)), __LINE__);
        }
        $this->permanent = $permanent;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempBizareas
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
