<?php

namespace App\ExternalApis\ConsendoAxp\Soap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AxpTempHist StructType
 * @subpackage Structs
 */
class AxpTempHist extends AbstractStructBase
{
    /**
     * The tid
     * @var int
     */
    public $tid;
    /**
     * The start
     * @var string
     */
    public $start;
    /**
     * The stop
     * @var string
     */
    public $stop;
    /**
     * The label
     * Meta informations extracted from the WSDL
     * - label: stop
     * @var string
     */
    public $label;
    /**
     * The employer
     * @var string
     */
    public $employer;
    /**
     * The label1_hist
     * @var string
     */
    public $label1_hist;
    /**
     * The label2_hist
     * @var string
     */
    public $label2_hist;
    /**
     * Constructor method for AxpTempHist
     * @uses AxpTempHist::setTid()
     * @uses AxpTempHist::setStart()
     * @uses AxpTempHist::setStop()
     * @uses AxpTempHist::setLabel()
     * @uses AxpTempHist::setEmployer()
     * @uses AxpTempHist::setLabel1_hist()
     * @uses AxpTempHist::setLabel2_hist()
     * @param int $tid
     * @param string $start
     * @param string $stop
     * @param string $label
     * @param string $employer
     * @param string $label1_hist
     * @param string $label2_hist
     */
    public function __construct($tid = null, $start = null, $stop = null, $label = null, $employer = null, $label1_hist = null, $label2_hist = null)
    {
        $this
            ->setTid($tid)
            ->setStart($start)
            ->setStop($stop)
            ->setLabel($label)
            ->setEmployer($employer)
            ->setLabel1_hist($label1_hist)
            ->setLabel2_hist($label2_hist);
    }
    /**
     * Get tid value
     * @return int|null
     */
    public function getTid()
    {
        return $this->tid;
    }
    /**
     * Set tid value
     * @param int $tid
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempHist
     */
    public function setTid($tid = null)
    {
        // validation for constraint: int
        if (!is_null($tid) && !is_numeric($tid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($tid)), __LINE__);
        }
        $this->tid = $tid;
        return $this;
    }
    /**
     * Get start value
     * @return string|null
     */
    public function getStart()
    {
        return $this->start;
    }
    /**
     * Set start value
     * @param string $start
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempHist
     */
    public function setStart($start = null)
    {
        // validation for constraint: string
        if (!is_null($start) && !is_string($start)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($start)), __LINE__);
        }
        $this->start = $start;
        return $this;
    }
    /**
     * Get stop value
     * @return string|null
     */
    public function getStop()
    {
        return $this->stop;
    }
    /**
     * Set stop value
     * @param string $stop
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempHist
     */
    public function setStop($stop = null)
    {
        // validation for constraint: string
        if (!is_null($stop) && !is_string($stop)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($stop)), __LINE__);
        }
        $this->stop = $stop;
        return $this;
    }
    /**
     * Get label value
     * @return string|null
     */
    public function getLabel()
    {
        return $this->label;
    }
    /**
     * Set label value
     * @param string $label
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempHist
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($label)), __LINE__);
        }
        $this->label = $label;
        return $this;
    }
    /**
     * Get employer value
     * @return string|null
     */
    public function getEmployer()
    {
        return $this->employer;
    }
    /**
     * Set employer value
     * @param string $employer
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempHist
     */
    public function setEmployer($employer = null)
    {
        // validation for constraint: string
        if (!is_null($employer) && !is_string($employer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($employer)), __LINE__);
        }
        $this->employer = $employer;
        return $this;
    }
    /**
     * Get label1_hist value
     * @return string|null
     */
    public function getLabel1_hist()
    {
        return $this->label1_hist;
    }
    /**
     * Set label1_hist value
     * @param string $label1_hist
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempHist
     */
    public function setLabel1_hist($label1_hist = null)
    {
        // validation for constraint: string
        if (!is_null($label1_hist) && !is_string($label1_hist)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($label1_hist)), __LINE__);
        }
        $this->label1_hist = $label1_hist;
        return $this;
    }
    /**
     * Get label2_hist value
     * @return string|null
     */
    public function getLabel2_hist()
    {
        return $this->label2_hist;
    }
    /**
     * Set label2_hist value
     * @param string $label2_hist
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempHist
     */
    public function setLabel2_hist($label2_hist = null)
    {
        // validation for constraint: string
        if (!is_null($label2_hist) && !is_string($label2_hist)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($label2_hist)), __LINE__);
        }
        $this->label2_hist = $label2_hist;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\ExternalApis\ConsendoAxp\Soap\StructType\AxpTempHist
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
